/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package knotjob.links;

import java.util.ArrayList;
import knotjob.dialogs.DialogWrap;

/**
 *
 * @author Dirk
 */
public class CombMinimizer extends Thread {
    
    private boolean cancelled;
    private boolean aborted;
    private int counter;
    private final int counterMax;
    private final boolean checkCounter;
    private final ArrayList<LinkData> theLinks;
    private final DialogWrap frame;
    
    public CombMinimizer(ArrayList<LinkData> thLnks, DialogWrap frm) {
        theLinks = thLnks;
        frame = frm;
        cancelled = false;
        aborted = false;
        checkCounter = true;
        counterMax = 10000;
    }
    
    public CombMinimizer(LinkData lnk, int max) {
        theLinks = new ArrayList<LinkData>();
        theLinks.add(lnk);
        checkCounter = true;
        counterMax = max;
        frame = null;
    }
    
    @Override
    public void run() {
        int i = 0;
        while (!cancelled && i < theLinks.size()) {
            counter = 0;
            minimize(theLinks.get(i));
            i++;
        }
        frame.dispose();
    }

    public Link getMinimized() {
        return getOptimized(theLinks.get(0).chosenLink()).girthMinimize();
    }
    
    private void minimize(LinkData link) {
        frame.setText(link.name);
        Link optLink = getOptimized(link.chosenLink());
        if (optLink.crossingLength() < link.chosenLink().crossingLength()) 
            link.links.add(optLink.girthMinimize());
    }
    
    private Link getOptimized(Link link) {
        Link optimalLink = combineCrossings(link);
        ReidemeisterMove emptyMove = new ReidemeisterMove();
        ArrayList<ReidemeisterMove> moves = findReidemeister(link);
        for (ReidemeisterMove move : moves) {
            counter++;
            if (!aborted && (!checkCounter || counter < counterMax)) {
                Link newLink = linkFromRMove(link, move);
                newLink = optimize(newLink,emptyMove);
                if (newLink.crossingLength() < optimalLink.crossingLength()) optimalLink = newLink;
            }
            else break;
        }
        return optimalLink;
    }
    
    private Link combineCrossings(Link link) {
        int i = 0;
        boolean sequence = false;
        int s1 = 0;
        int s2 = 0;
        int q1 = 0;
        int q2 = 0;//q's are position, s's are values
        int[] crossings = link.cloneCrossings();
        int[][] paths = link.clonePaths();
        ArrayList<int[]> ors = link.cloneOr();
        while (i < crossings.length-1) {
            if (sequence) {
                int u = i+1;
                boolean found = false;
                while (u < crossings.length && !found) {
                    if (contains(paths[u], s1, s2, crossings[u])) {
                        found = true;
                        boolean fnd = false;
                        int y = 0;
                        while (!fnd) {
                            if (paths[u][y] == s2) fnd = true;
                            else y++;
                        }
                        int t1 = (y+1)%4;
                        int p1 = (y+2)%4;
                        int p2 = (y+3)%4;
                        for (int[] or : ors) {
                            if (or[0] == i) {
                                if (or[1] == (q2+2)%4 || or[1] == (q2+3)%4) {
                                    if ((Math.abs(crossings[u]))%2 != 0) {
                                        if (or[1] %2 != 0) or[1] = (or[1] + 1)%4;
                                        else or[1] = (or[1] + 3)%4;
                                    }
                                } 
                            }
                            if (or[0] == u) {
                                or[0] = i;
                                if (or[1] == y || or[1] == t1) {
                                    if (Math.abs(crossings[i])%2 != 0) or[1] = q2;
                                    else or[1] = (q2+1)%4;
                                }
                                else if (y % 2 == 0) or[1] = (or[1]+1)%4;
                            }
                        }
                        int[] newcrossings = new int[crossings.length-1];
                        System.arraycopy(crossings, 0, newcrossings, 0, i);
                        if (t1%2 != 0) newcrossings[i] = crossings[i]-crossings[u];
                        else newcrossings[i] = crossings[i]+crossings[u];
                        System.arraycopy(crossings, i+1, newcrossings, i+1, u - (i+1));
                        for (int j = u; j < newcrossings.length; j++) newcrossings[j] = crossings[j+1];
                        int[][] newpaths = new int[paths.length-1][4];
                        for (int j = 0; j < i; j++) {
                            for (int k = 0; k < 4; k++) 
                                newpaths[j][k] = theNewNumber(paths[j][k],s1,s2,2*paths.length);
                        }
                        newpaths[i][q1] = theNewNumber(paths[i][q1],s1,s2,2*paths.length);
                        newpaths[i][q2] = theNewNumber(paths[i][q2],s1,s2,2*paths.length);
                        newpaths[i][(q1+1)%4] = theNewNumber(paths[u][p1],s1,s2,2*paths.length);
                        newpaths[i][(q1+2)%4] = theNewNumber(paths[u][p2],s1,s2,2*paths.length);
                        for (int j = i+1; j < u; j++) {
                            for (int k = 0; k < 4; k++)
                                newpaths[j][k] = theNewNumber(paths[j][k],s1,s2,2*paths.length);
                        }
                        for (int j = u; j < newpaths.length; j++) {
                            for (int k = 0; k < 4; k++)
                                newpaths[j][k] = theNewNumber(paths[j+1][k],s1,s2,2*paths.length);
                        }
                        paths = newpaths;
                        crossings = newcrossings;
                        s1 = paths[i][(q1+1)%4];
                        s2 = paths[i][(q1+2)%4];
                    }
                    u++;
                }
                if (!found) {
                    sequence = false;
                    i++;
                }
            }
            else {
                q2 = 0;
                q1 = 1;
                boolean found = false;
                while (!found & q2 < 4) {
                    s1 = paths[i][(q1+1)%4];
                    s2 = paths[i][(q1+2)%4];
                    int u = i+1;
                    while (!found & u < paths.length) {
                        if (Math.abs(crossings[i]) == 1 || (q1%2 == 0)) {
                            if (contains(paths[u], s1, s2, crossings[u])) found = true;
                        }
                        if (!found) u++;
                    }
                    if (!found) {
                        q2++;
                        q1 = (q2+1)%4;
                    }
                }
                if (found) {
                    sequence = true;
                    if (q2%2 ==0) {
                        int help = paths[i][0];
                        paths[i][0] = paths[i][1];
                        paths[i][1] = paths[i][2];
                        paths[i][2] = paths[i][3];
                        paths[i][3] = help;
                        crossings[i] = - crossings[i];
                        q1 = (q1+3)%4;
                        q2 = (q2+3)%4;
                        for (int[] or : ors) {
                            if (or[0] == i) or[1] = (or[1]+3)%4;
                        }
                    }
                }
                else i++;
            }
        }
        return new Link(crossings, paths);//, ors, link.unComponents());
    }
    
    private boolean contains(int[] path, int a, int b, int crs) {
        boolean found = false;
        int i = 0;
        int inc = 1;
        if (Math.abs(crs) > 1) inc++;
        while (!found && i < 4) {
            if (path[i] == a && path[(i+3)%4] == b) found = true;
            else i = i+inc;
        }
        return found;
    }
    
    private int theNewNumber(int old, int s1, int s2, int max) {
        int nu = old;
        int big = s2;
        int sma = s1;
        if (s1 > s2) {
            big = s1;
            sma = s2;
        }
        if (sma == 1 || big == max) {
            if (sma == 1) {
                if (old < big) nu = old - 1;
                else nu = old -2;
            }
            else {
                if (old >= sma) nu = old - 1;
            }
        }
        else {
            if (old >= sma && old <= big) nu = old - 1;
            if (old > big) nu = old - 2;
        }
        return nu;
    }
    
    private Link linkFromRMove(Link link, ReidemeisterMove move) {
        Link newLink = new Link(link.cloneCrossings(), link.clonePaths(), link.cloneOr(), 
                link.unComponents());
        int changeX = (move.u+1)%4;
        int changeY = (move.v+1)%4;
        int keepZX = move.t;
        int keepZY = move.s;
        boolean xBigger = ((4+move.t-move.s)%4 == 1);
        int moveZX, moveZY;
        if (xBigger) {
            moveZX = (keepZX+1)%4;
            moveZY = (keepZY+3)%4;
        }
        else {
            moveZX = (keepZX+3)%4;
            moveZY = (keepZY+1)%4;
        }
        if (contains(link.getPath(move.z), link.getPath(move.x, changeX))) {
            newLink.setPath(move.x, changeX, link.getPath(move.z, moveZX));
            newLink.setPath(move.x, (changeX+2)%4, link.getPath(move.x, changeX));
            newLink.setPath(move.z, keepZX, link.getPath(move.x, (changeX+2)%4));
            newLink.setPath(move.z, moveZX, link.getPath(move.x, changeX));
        }
        else {
            newLink.setPath(move.x, (changeX+2)%4, link.getPath(move.z, moveZX));
            newLink.setPath(move.x, changeX, link.getPath(move.x, (changeX+2)%4));
            newLink.setPath(move.z, keepZX, link.getPath(move.x, changeX));
            newLink.setPath(move.z, moveZX, link.getPath(move.x, (changeX+2)%4));
        }
        if (contains(link.getPath(move.z), link.getPath(move.y, changeY))) {
            newLink.setPath(move.y, changeY, link.getPath(move.z, moveZY));
            newLink.setPath(move.y, (changeY+2)%4, link.getPath(move.y, changeY));
            newLink.setPath(move.z, keepZY, link.getPath(move.y, (changeY+2)%4));
            newLink.setPath(move.z, moveZY, link.getPath(move.y, changeY));
        }
        else {
            newLink.setPath(move.y, (changeY+2)%4, link.getPath(move.z, moveZY));
            newLink.setPath(move.y, changeY, link.getPath(move.y, (changeY+2)%4));
            newLink.setPath(move.z, keepZY, link.getPath(move.y, changeY));
            newLink.setPath(move.z, moveZY, link.getPath(move.y, (changeY+2)%4));
        }
        return newLink;
    }
    
    private boolean contains(int[] aray, int u) {
        boolean inthere = false;
        int t = 0;
        while (t < aray.length & !inthere) {
            if (aray[t] == u) inthere = true;
            else t++;
        }
        return inthere;
    }
    
    private Link optimize(Link link, ReidemeisterMove move) {
        Link optLink = combineCrossings(link);
        link = combineCrossings(link);
        ReidemeisterMove emptyMove = new ReidemeisterMove();
        ArrayList<ReidemeisterMove> moves = findReidemeister(link);
        for (ReidemeisterMove mov : moves) {
            counter++;
            if (!aborted && (!checkCounter || counter < counterMax)) {
                if (mov.compareTo(move) > 0) {
                    Link newLink = linkFromRMove(link, mov);
                    newLink = combineCrossings(newLink);
                    if (newLink.crossingLength() < optLink.crossingLength()) newLink = optimize(newLink, emptyMove);
                    else newLink = optimize(newLink,mov);
                    if (newLink.crossingLength() < optLink.crossingLength()) optLink = newLink;
                }
            }
            else break;
        }
        return optLink;
    }
    
    private ArrayList<ReidemeisterMove> findReidemeister(Link link) {
        ArrayList<ReidemeisterMove> moves = new ArrayList<ReidemeisterMove>();
        int a = 0;
        while (a < link.crossingLength()-1) {
            if (Math.abs(link.getCross(a)) == 1) {
                int b = a+1;
                while (b < link.crossingLength()) {
                    if (Math.abs(link.getCross(b)) == 1) {
                        boolean found = false;
                        int u = 0;
                        int v = 0;
                        while (!found & u < 4) {
                            v = 0;
                            boolean abovea = (((u % 2) == 0) == (link.getCross(a) < 0));
                            while (!found & v < 4) {
                                boolean aboveb = (((v % 2) == 0) == (link.getCross(b) < 0));
                                if ((aboveb == abovea) && 
                                        (link.getPath(a, u) == link.getPath(b, v))) found = true;
                                else v++;
                            }
                            if (!found) u++;
                        }
                        if (found) {// possible Reidemeister Move III (or II, but not checking for those)
                            for (int c = 0; c < link.crossingLength(); c++) {
                                if (c != a & c != b ) {
                                    boolean gfund = false;
                                    boolean order = true;
                                    int t = 0;
                                    int s = 1;
                                    while (!gfund & t < 3) {
                                        s = t+1;
                                        while (!gfund & s < 4) {
                                            int pa = link.getPath(c, t);
                                            int pb = link.getPath(c, s);
                                            if (contains(link.getPath(a), pa) && 
                                                    contains(link.getPath(b), pb)) gfund = true;
                                            else if (contains(link.getPath(b), pa) && 
                                                    contains(link.getPath(a), pb)) {
                                                gfund = true;
                                                order = false;
                                            }
                                            if (!gfund) s++;
                                        }
                                        if (!gfund) t++;
                                    }
                                    if (gfund) {
                                        ReidemeisterMove move;
                                        if (order) move = new ReidemeisterMove(a,b,c,u,v,t,s);
                                        else move = new ReidemeisterMove(a,b,c,u,v,s,t);
                                        moves.add(move);
                                    }
                                }
                            }
                        }
                    }
                    b++;
                }
            }
            a++;
        }
        return moves;
    }
    
    private class ReidemeisterMove implements Comparable<ReidemeisterMove> {
        int x,y,z;
        int u,v,t,s;
        
        ReidemeisterMove() {
            x = 0;
            y = 0;
            z = 0;
            u = 0;
            v = 0;
            t = 0;
            s = 0;
        }
        
        ReidemeisterMove(int a, int b, int c, int d, int e, int f, int g) {
            x = a;
            y = b;
            z = c;
            u = d;
            v = e;
            t = f;
            s = g;
        }
        
        @Override
        public int compareTo(ReidemeisterMove mov) {
            int w = x - mov.x;
            if (w == 0) w = y - mov.y;
            if (w == 0) w = z - mov.z;
            return w;
        }
        
        void printOut() {
            System.out.println("Crossings : "+x+" "+y+" "+z);
            System.out.println("Path positions : "+u+" "+v+" "+t+" "+s);
            System.out.println();
        }
    }
}
